$ set process/parse=extend
$ set default MYSQL_ROOT:[VMS]
$ OPENSSL = 0
$ VMS_SSL = 0
$ ZLIB = 0
$ if p1 .eqs. "OPENSSL" then OPENSSL = 1
$ if p1 .eqs. "VMS_SSL" then VMS_SSL = 1
$ if p2 .eqs. "ZLIB" then ZLIB = 1
$ if p3 .eqs. "CLIENT" then $ define MYSQL_CLIENT_OR_SERVER MYSQL_CLIENT
$ if p3 .eqs. "SERVER" then $ define MYSQL_CLIENT_OR_SERVER MYSQL_SERVER
$
$ copy MYSQL_ROOT:[VMS.MYSQL]my_config.h_ini -
       MYSQL_ROOT:[VMS.MYSQL]my_config.h
$
$ copy MYSQL_ROOT:[VMS.INNOBASE]ib_config.h -
       MYSQL_ROOT:[innobase.include]ib_config.h
$
$ if OPENSSL .or. VMS_SSL
$ then
$    open/append fconf MYSQL_ROOT:[VMS.MYSQL]my_config.h
$    write fconf "/* crypt */"
$    write fconf "#define HAVE_CRYPT 1"
$    write fconf "/* OpenSSL */"
$    write fconf "#define HAVE_OPENSSL 1"
$    close fconf
$ endif
$
$ if ZLIB
$ then
$    open/append fconf MYSQL_ROOT:[VMS.MYSQL]my_config.h
$    write fconf "/* ZLIB and compress: */"
$    write fconf "#define HAVE_COMPRESS 1"
$    close fconf
$ endif
$
$ open/append fconf MYSQL_ROOT:[VMS.MYSQL]my_config.h
$ write fconf "#define PTHREAD_NAMES_ARE_UPCASE 1"
$ if p1 .eqs. "VMS_SSL" then $ write fconf "#define SSL_NAMES_ARE_UPCASE 1"
$ write fconf "#include <upcase_names.h>"
$ close fconf
$
$ arch_name = f$getsyi("arch_name")
$ if arch_name .eqs. "IA64"
$ then
$    libcxxstd = ""
$ else
$    libcxxstd = "1"
$ endif
$ if f$trnlnm("MYSQL_CLIENT_OR_SERVER") .eqs. "MYSQL_SERVER"
$ then
$     call genopt "mysqld.opt" OPENSSL VMS_SSL ZLIB 'libcxxstd'
$ else
$     call genopt "myisamchk.opt" OPENSSL VMS_SSL ZLIB
$     call genopt "mysql.opt" OPENSSL VMS_SSL ZLIB 'libcxxstd'
$     call genopt "mysqladmin.opt" OPENSSL VMS_SSL ZLIB
$     call genopt "mysqlbinlog.opt" OPENSSL VMS_SSL ZLIB 'libcxxstd'
$     call genopt "mysqlcheck.opt" OPENSSL VMS_SSL ZLIB
$     call genopt "mysqlclient.opt" OPENSSL VMS_SSL ZLIB
$     call genopt "mysqlclient_shr.opt" OPENSSL VMS_SSL ZLIB
$     call genopt "mysqldump.opt" OPENSSL VMS_SSL ZLIB
$     call genopt "mysqlimport.opt" OPENSSL VMS_SSL ZLIB
$     call genopt "mysqlshow.opt" OPENSSL VMS_SSL ZLIB
$     call genopt "mysqltest.opt" OPENSSL VMS_SSL ZLIB
$ endif
$
$
$ copy MYSQL_ROOT:[VMS.MYSQL]my_config.h -
       MYSQL_ROOT:[include]my_config.h
$ copy MYSQL_ROOT:[VMS.MYSQL]upcase_names.h -
       MYSQL_ROOT:[include]upcase_names.h
$
$ if f$trnlnm("MYSQL_CLIENT_OR_SERVER") .eqs. "MYSQL_SERVER"
$ then
$     @MYSQL_ROOT:[VMS.INNOBASE.scripts]build_all_mms
$ endif
$ @MYSQL_ROOT:[VMS.MYSQL.scripts]build_all_mms
$ if f$trnlnm("MYSQL_CLIENT_OR_SERVER") .eqs. "MYSQL_CLIENT"
$ then
$     @MYSQL_ROOT:[VMS.MYSQL]build_client_library
$     @MYSQL_ROOT:[VMS.MYSQL]build_loadrepository
$     @MYSQL_ROOT:[VMS.MYSQL]build_loadobject
$ endif
$
$ exit
$ 
$ genopt: subroutine
$ 
$ copy mysql_root:[vms.mysql]'p1'_ini mysql_root:[vms.mysql]'p1'
$
$ open/append fopt mysql_root:[vms.mysql]'p1'
$
$ if 'p4' .eq. 1
$ then
$     write fopt "LIBZ_SHR32/share"
$ endif
$
$ if 'p2' .eq. 1
$ then
$     write fopt "SSLLIB:LIBSSL.OLB/LIB"
$     write fopt "SSLLIB:LIBCRYPTO.OLB/LIB"
$ endif
$
$ if 'p3' .eq. 1
$ then
$     write fopt "SYS$SHARE:SSL$LIBSSL_SHR32.EXE/SHARE"
$     write fopt "SYS$SHARE:SSL$LIBCRYPTO_SHR32.EXE/SHARE"
$ endif
$
$ if p5 .nes. ""
$ then
$     write fopt "sys$share:LIBCXXSTD.OLB/lib"
$ endif
$
$ close fopt
$
$ return
$ endsubroutine
