$ set noverify
$ set process/parse_style=extended
$
$ set default mysql_root:[client]
$ copy mysql.cc mysql.cc$o
$ gpatch -u
--- mysql.cc$o	Fri Jun 11 21:59:17 2004
+++ mysql.cc	Fri Jun 11 21:59:18 2004
@@ -79,6 +79,13 @@
 #undef bcmp				// Fix problem with new readline
 #if defined( __WIN__) || defined(OS2)
 #include <conio.h>
+#elif defined(__VMS)
+#include <unixlib.h>
+#include <namdef.h>
+static char VMS_Resname[NAM$C_MAXRSS + 1];
+extern "C" {
+extern char *vms__readline(char *prompt);
+};
 #elif !defined(__NETWARE__)
 #include <readline/readline.h>
 #define HAVE_READLINE
@@ -821,6 +828,20 @@
       linebuffer[0]= (char) sizeof(linebuffer);
       line= _cgets(linebuffer);
 #endif /* __NETWARE__ */
+#elif defined(__VMS)
+      if (opt_outfile)
+      {
+        if (glob_buffer.is_empty())
+            fflush(OUTFILE);
+        fputs(glob_buffer.is_empty() ? construct_prompt() :
+              !in_string ? "    -> " :
+              in_string == '\'' ?
+              "    '> " : "    \"> ", OUTFILE);
+      }
+      line=vms__readline((char*) (glob_buffer.is_empty() ? construct_prompt() :
+			     !in_string ? "    -> " :
+			     in_string == '\'' ?
+			     "    '> " : "    \"> "));
 #else
       if (opt_outfile)
 	fputs(prompt, OUTFILE);
@@ -1965,6 +1986,13 @@
 }
 #endif
 
+#ifdef __VMS
+static int
+to_vms_action(char* str, int type) {
+  strncpy(VMS_Resname, str, sizeof(VMS_Resname));
+  return 0;   /*  no further file translation */
+}
+#endif
 
 /*
   Sorry, you can't send the result to an editor in Win32
@@ -1990,8 +2018,18 @@
 
   if (!(editor = (char *)getenv("EDITOR")) &&
       !(editor = (char *)getenv("VISUAL")))
+#ifdef __VMS
+    editor = "edit";
+#else
     editor = "vi";
+#endif
+
+#ifdef __VMS
+  (void)decc$to_vms(filename, to_vms_action, 0, 0);
+  strxmov(buff,editor," ",VMS_Resname,NullS);
+#else
   strxmov(buff,editor," ",filename,NullS);
+#endif
   (void) system(buff);
 
   MY_STAT stat_arg;

$ rename mysql.cc mysql.cc
$ set default mysql_root:[dbug]
$ copy dbug.c dbug.c$o
$ gpatch -u
--- dbug.c$o	Fri Jun 11 21:59:18 2004
+++ dbug.c	Fri Jun 11 21:59:18 2004
@@ -117,6 +117,13 @@
 
 #define TRACING (stack -> flags & TRACE_ON)
 #define DEBUGGING (stack -> flags & DEBUG_ON)
+
+#ifdef __VMS
+#  ifdef PROFILING
+#    undef PROFILING
+#  endif
+#endif
+
 #define PROFILING (stack -> flags & PROFILE_ON)
 #define STREQ(a,b) (strcmp(a,b) == 0)
 

$ rename dbug.c dbug.c
$ set default mysql_root:[heap]
$ copy hp_open.c hp_open.c$o
$ gpatch -u
--- hp_open.c$o	Fri Jun 11 21:59:18 2004
+++ hp_open.c	Fri Jun 11 21:59:19 2004
@@ -17,9 +17,6 @@
 /* open a heap-database */
 
 #include "heapdef.h"
-#ifdef VMS
-#include "hp_static.c"			/* Stupid vms-linker */
-#endif
 
 static void init_block(HP_BLOCK *block,uint reclength,ulong min_records,
 		       ulong max_records);

$ rename hp_open.c hp_open.c
$ set default mysql_root:[include]
$ copy my_global.h my_global.h$o
$ gpatch -u
--- my_global.h$o	Fri Jun 11 21:59:19 2004
+++ my_global.h	Fri Jun 11 21:59:19 2004
@@ -250,11 +250,11 @@
 # endif
 #endif /* TIME_WITH_SYS_TIME */
 #ifdef HAVE_UNISTD_H
-#if defined(HAVE_OPENSSL) && !defined(__FreeBSD__) && !defined(NeXT) && !defined(__OpenBSD__)
+#if defined(HAVE_OPENSSL) && !defined(__FreeBSD__) && !defined(NeXT) && !defined(__OpenBSD__) && !defined(__VMS)
 #define crypt unistd_crypt
 #endif
 #include <unistd.h>
-#ifdef HAVE_OPENSSL
+#if defined(HAVE_OPENSSL) && !defined(__VMS)
 #undef crypt
 #endif
 #endif
@@ -701,17 +701,33 @@
 typedef char	int8;		/* Signed integer >= 8	bits */
 typedef short	int16;		/* Signed integer >= 16 bits */
 #endif
+
 #ifndef HAVE_UCHAR
 typedef unsigned char	uchar;	/* Short for unsigned char */
 #endif
+#ifdef __VMS
+#ifndef HAVE_INT_8_16_32
+typedef unsigned char	uint8;	/* Short for unsigned integer >= 8  bits */
+typedef unsigned short	uint16; /* Short for unsigned integer >= 16 bits */
+#endif
+#else
 typedef unsigned char	uint8;	/* Short for unsigned integer >= 8  bits */
 typedef unsigned short	uint16; /* Short for unsigned integer >= 16 bits */
+#endif
 
 #if SIZEOF_INT == 4
 #ifndef HAVE_INT_8_16_32
 typedef int		int32;
 #endif
+
+#ifdef __VMS
+#ifndef HAVE_INT_8_16_32
+typedef unsigned int	uint32; /* Short for unsigned integer >= 32 bits */
+#endif
+#else
 typedef unsigned int	uint32; /* Short for unsigned integer >= 32 bits */
+#endif
+
 #elif SIZEOF_LONG == 4
 #ifndef HAVE_INT_8_16_32
 typedef long		int32;

$ rename my_global.h my_global.h
$ set default mysql_root:[include]
$ copy my_net.h my_net.h$o
$ gpatch -u
--- my_net.h$o	Fri Jun 11 21:59:19 2004
+++ my_net.h	Fri Jun 11 21:59:19 2004
@@ -44,7 +44,7 @@
 #include <sys/ioctl.h>
 #endif
 
-#if !defined(MSDOS) && !defined(__WIN__) && !defined(HAVE_BROKEN_NETINET_INCLUDES) && !defined(__BEOS__) && !defined(__NETWARE__)
+#if !defined(MSDOS) && !defined(__WIN__) && !defined(HAVE_BROKEN_NETINET_INCLUDES) && !defined(__BEOS__) && !defined(__NETWARE__) && !defined(__VMS)
 #include <netinet/in_systm.h>
 #include <netinet/in.h>
 #include <netinet/ip.h>

$ rename my_net.h my_net.h
$ set default mysql_root:[include]
$ copy my_pthread.h my_pthread.h$o
$ gpatch -u
--- my_pthread.h$o	Fri Jun 11 21:59:20 2004
+++ my_pthread.h	Mon Jun 14 19:44:54 2004
@@ -28,6 +28,7 @@
 extern "C" {
 #endif /* __cplusplus */ 
 
+
 #if defined(__WIN__) || defined(OS2)
 
 #ifdef OS2
@@ -227,6 +228,32 @@
 
 #else /* Normal threads */
 
+#ifdef __VMS
+#include <signal.h>
+#ifndef HAVE_PTHREAD_KILL
+#define pthread_kill(A,B) pthread_dummy(0)
+#endif
+
+#ifndef HAVE_MY_PTHREAD_SETPRIO
+#define my_pthread_setprio(A,B) pthread_dummy(0)
+#endif
+
+#ifndef HAVE_MY_PTHREAD_ATTR_SETPRIO
+#define my_pthread_attr_setprio(A,B) pthread_dummy(0)
+#endif
+
+#ifndef HAVE_PTHREAD_SIGNAL
+#define pthread_signal(A,B) pthread_dummy(0)
+#endif
+#define sigset(A,B) pthread_signal((A),(void (*)(int)) (B))
+
+#ifndef HAVE_PTHREAD_SIGMASK
+#define pthread_sigmask(A,B,C) sigprocmask((A),(B),(C))
+#endif
+
+#endif /* defined __VMS */
+
+
 #ifdef HAVE_rts_threads
 #define sigwait org_sigwait
 #include <signal.h>
@@ -435,7 +462,7 @@
 #define pthread_kill(A,B) pthread_dummy(0)
 #undef	pthread_detach_this_thread
 #define pthread_detach_this_thread() { pthread_t tmp=pthread_self() ; pthread_detach(&tmp); }
-#elif !defined(__NETWARE__) /* HAVE_PTHREAD_ATTR_CREATE && !HAVE_SIGWAIT */
+#elif !defined(__NETWARE__) && !defined(__VMS) /* HAVE_PTHREAD_ATTR_CREATE && !HAVE_SIGWAIT */
 #define HAVE_PTHREAD_KILL
 #endif
 

$ rename my_pthread.h my_pthread.h
$ set default mysql_root:[include]
$ copy my_sys.h my_sys.h$o
$ gpatch -u
--- my_sys.h$o	Fri Jun 11 21:59:20 2004
+++ my_sys.h	Fri Jun 11 21:59:20 2004
@@ -170,7 +170,11 @@
 #if defined(__GNUC__) && !defined(HAVE_ALLOCA_H) && ! defined(alloca)
 #define alloca __builtin_alloca
 #endif /* GNUC */
+#ifdef __VMS
+#define my_alloca(SZ) __ALLOCA((size_t) (SZ))
+#else
 #define my_alloca(SZ) alloca((size_t) (SZ))
+#endif
 #define my_afree(PTR) {}
 #else
 #define my_alloca(SZ) my_malloc(SZ,MYF(0))

$ rename my_sys.h my_sys.h
$ set default mysql_root:[innobase.include]
$ copy univ.i univ.i$o
$ gpatch -u
--- univ.i$o	Fri Jun 11 21:59:20 2004
+++ univ.i	Fri Jun 11 21:59:21 2004
@@ -40,7 +40,11 @@
 #undef VERSION
 
 /* Include the header file generated by GNU autoconf */
+#ifdef __VMS
+#include <ib_config.h>
+#else
 #include "../ib_config.h"
+#endif
 
 #ifdef HAVE_SCHED_H
 #include <sched.h>

$ rename univ.i univ.i
$ set default mysql_root:[isam]
$ copy open.c open.c$o
$ gpatch -u
--- open.c$o	Fri Jun 11 21:59:21 2004
+++ open.c	Fri Jun 11 21:59:21 2004
@@ -24,9 +24,6 @@
 #include <process.h>			/* Prototype for getpid */
 #endif
 #endif
-#ifdef VMS
-#include "static.c"
-#endif
 
 static void setup_functions(ISAM_SHARE *info);
 static void setup_key_functions(N_KEYDEF *keyinfo);

$ rename open.c open.c
$ set default mysql_root:[libmysqld]
$ copy libmysqld.c libmysqld.c$o
$ gpatch -u
--- libmysqld.c$o	Fri Jun 11 21:59:21 2004
+++ libmysqld.c	Fri Jun 11 21:59:22 2004
@@ -234,7 +234,13 @@
 
   /* Clear receive buffer and vio packet list */
   net_clear(net);
+#ifdef __VMS
+#ifdef EMBEDDED_LIBRARY
+  vio_reset(net->vio);
+#endif
+#else
   vio_reset(net->vio);
+#endif
 
   result = lib_dispatch_command(command, net, arg,length);
   if (!skipp_check)

$ rename libmysqld.c libmysqld.c
$ set default mysql_root:[merge]
$ copy mrg_open.c mrg_open.c$o
$ gpatch -u
--- mrg_open.c$o	Fri Jun 11 21:59:22 2004
+++ mrg_open.c	Fri Jun 11 21:59:22 2004
@@ -19,9 +19,6 @@
 #include "mrg_def.h"
 #include <stddef.h>
 #include <errno.h>
-#ifdef VMS
-#include "static.c"
-#endif
 
 /*	open a MERGE-database.
 

$ rename mrg_open.c mrg_open.c
$ set default mysql_root:[mysys]
$ copy default.c default.c$o
$ gpatch -u
--- default.c$o	Fri Jun 11 21:59:22 2004
+++ default.c	Fri Jun 11 21:59:22 2004
@@ -47,6 +47,8 @@
 "C:/",
 #elif defined(__NETWARE__)
 "sys:/etc/",
+#elif defined(__VMS)
+"/mysql_root/vms/",
 #else
 "/etc/",
 #endif

$ rename default.c default.c
$ set default mysql_root:[mysys]
$ copy mf_pack.c mf_pack.c$o
$ gpatch -u
--- mf_pack.c$o	Fri Jun 11 21:59:22 2004
+++ mf_pack.c	Fri Jun 11 21:59:23 2004
@@ -14,16 +14,14 @@
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
 
+#ifdef __VMS
+#include "my_global.h"
+#endif
 #include "mysys_priv.h"
 #include <m_string.h>
 #ifdef HAVE_PWD_H
 #include <pwd.h>
 #endif
-#ifdef VMS
-#include <rms.h>
-#include <iodef.h>
-#include <descrip.h>
-#endif /* VMS */
 
 static my_string NEAR_F expand_tilde(my_string *path);
 
@@ -459,7 +457,7 @@
 
 my_string intern_filename(my_string to, const char *from)
 {
-#ifndef VMS
+
   {
     uint length;
     char buff[FN_REFLEN];
@@ -472,86 +470,4 @@
     (void) strcat(to,from+length);
     return (to);
   }
-#else	/* VMS */
-
-	/* change 'dev:[lib]xxx' to 'dev:lib/xxx' */
-	/* change 'dev:xxx' to 'dev:xxx' */
-	/* change 'dev:x/y/[.lib]' to 'dev:x/y/lib/ */
-	/* change '[.lib]' to './lib/' */
-	/* change '[x.y]' or '[x.][y]' or '[x][.y]' to '/x/y/' */
-	/* change '[000000.x] or [x.000000]' to '/x/' */
-
-  int par_length,root_length;
-  my_string pos,from_pos,to_pos,end_pos;
-  char buff[FN_REFLEN];
-
-  convert_dirname(buff,from,NullS);		/* change '<>' to '[]' */
-  from_pos=buff;
-  if ((pos=strrchr(from_pos,FN_DEVCHAR)))	/* Skipp device part */
-  {
-    pos++;
-    to_pos=strnmov(to,from_pos,(size_s) (pos-from_pos));
-    from_pos=pos;
-  }
-  else
-    to_pos=to;
-
-  root_length=strlen(FN_C_ROOT_DIR);
-  if ((pos = strchr(from_pos,FN_C_BEFORE_DIR)) &&
-      (end_pos = strrchr(pos+1,FN_C_AFTER_DIR)))
-  {
-    to_pos=strnmov(to_pos,from_pos,(size_s) (pos-from_pos));
-				/* Copy all between ':' and '[' */
-    from_pos=pos+1;
-    if (strinstr(from_pos,FN_C_ROOT_DIR) == 1 &&
-	(from_pos[root_length] == FN_C_DIR_SEP ||
-	 from_pos[root_length] == FN_C_AFTER_DIR))
-    {
-      from_pos+=root_length+1;
-    }
-    else if (*from_pos == FN_C_DIR_SEP)
-      *(to_pos++) = FN_CURLIB;			/* Set ./ first */
-    *(to_pos++) = FN_LIBCHAR;
-
-    par_length=strlen(FN_C_PARENT_DIR);
-    pos=to_pos;
-    for (; from_pos <= end_pos ; from_pos++)
-    {
-      switch (*from_pos) {
-      case FN_C_DIR_SEP:
-      case FN_C_AFTER_DIR:
-	if (pos != to_pos)
-	{
-	  if ((int) (to_pos-pos) == root_length &&
-	      is_suffix(pos,FN_C_ROOT_DIR))
-	    to_pos=pos;				/* remove root-pos */
-	  else
-	  {
-	    *(to_pos++)=FN_LIBCHAR;		/* Find lib */
-	    pos=to_pos;
-	  }
-	}
-	break;
-      case FN_C_BEFORE_DIR:
-	break;
-      case '-':					/* *(FN_C_PARENT_DIR): */
-	if (to_pos[-1] == FN_LIBCHAR &&
-	    strncmp(from_pos,FN_C_PARENT_DIR,par_length) == 0)
-	{					/* Change '-' to '..' */
-	  to_pos=strmov(to_pos,FN_PARENTDIR);
-	  *(to_pos++)=FN_LIBCHAR;
-	  pos=to_pos;
-	  from_pos+=par_length-1;
-	  break;
-	}
-	/* Fall through */
-      default:
-	*(to_pos++)= *from_pos;
-	break;
-      }
-    }
-  }
-  (void) strmov(to_pos,from_pos);
-  return (to);
-#endif /* VMS */
 } /* intern_filename */

$ rename mf_pack.c mf_pack.c
$ set default mysql_root:[mysys]
$ copy my_init.c my_init.c$o
$ gpatch -u
--- my_init.c$o	Fri Jun 11 21:59:23 2004
+++ my_init.c	Fri Jun 11 21:59:23 2004
@@ -25,8 +25,7 @@
 /* extern int     getrusage(int, struct rusage *); */
 #endif
 #include <signal.h>
-#ifdef VMS
-#include <my_static.c>
+#ifdef __VMS
 #include <m_ctype.h>
 #endif
 #ifdef __WIN__
@@ -104,16 +103,13 @@
       my_win_init();
       if ((home_dir=getenv("HOME")) != 0)
 	home_dir=intern_filename(home_dir_buff,home_dir);
-#ifndef VMS
+#ifndef __VMS
       /* Default creation of new files */
       if ((str=getenv("UMASK")) != 0)
 	my_umask=(int) (atoi_octal(str) | 0600);
 	/* Default creation of new dir's */
       if ((str=getenv("UMASK_DIR")) != 0)
 	my_umask_dir=(int) (atoi_octal(str) | 0700);
-#endif
-#ifdef VMS
-      init_ctype();			/* Stupid linker don't link _ctype.c */
 #endif
       DBUG_PRINT("exit",("home: '%s'",home_dir));
     }

$ rename my_init.c my_init.c
$ set default mysql_root:[mysys]
$ copy my_lib.c my_lib.c$o
$ gpatch -u
--- my_lib.c$o	Fri Jun 11 21:59:23 2004
+++ my_lib.c	Fri Jun 11 21:59:23 2004
@@ -46,11 +46,6 @@
 # endif
 # endif
 #endif
-#ifdef VMS
-#include <rms.h>
-#include <iodef.h>
-#include <descrip.h>
-#endif
 
 #ifdef OS2
 #include "my_os2dirsrch.h"
@@ -216,7 +211,6 @@
 
 my_string directory_file_name (my_string dst, const char *src)
 {
-#ifndef VMS
 
   /* Process as Unix format: just remove test the final slash. */
 
@@ -232,123 +226,6 @@
   }
   return dst;
 
-#else	/* VMS */
-
-  long slen;
-  long rlen;
-  my_string ptr, rptr;
-  char bracket;
-  struct FAB fab = cc$rms_fab;
-  struct NAM nam = cc$rms_nam;
-  char esa[NAM$C_MAXRSS];
-
-  if (! src[0])
-    src="[.]";					/* Empty is == current dir */
-
-  slen = strlen (src) - 1;
-  if (src[slen] == FN_C_AFTER_DIR || src[slen] == FN_C_AFTER_DIR_2 ||
-      src[slen] == FN_DEVCHAR)
-  {
-	/* VMS style - convert [x.y.z] to [x.y]z, [x] to [000000]x */
-    fab.fab$l_fna = src;
-    fab.fab$b_fns = slen + 1;
-    fab.fab$l_nam = &nam;
-    fab.fab$l_fop = FAB$M_NAM;
-
-    nam.nam$l_esa = esa;
-    nam.nam$b_ess = sizeof esa;
-    nam.nam$b_nop |= NAM$M_SYNCHK;
-
-    /* We call SYS$PARSE to handle such things as [--] for us. */
-    if (SYS$PARSE(&fab, 0, 0) == RMS$_NORMAL)
-    {
-      slen = nam.nam$b_esl - 1;
-      if (esa[slen] == ';' && esa[slen - 1] == '.')
-	slen -= 2;
-      esa[slen + 1] = '\0';
-      src = esa;
-    }
-    if (src[slen] != FN_C_AFTER_DIR && src[slen] != FN_C_AFTER_DIR_2)
-    {
-	/* what about when we have logical_name:???? */
-      if (src[slen] == FN_DEVCHAR)
-      {				/* Xlate logical name and see what we get */
-	VOID(strmov(dst,src));
-	dst[slen] = 0;				/* remove colon */
-	if (!(src = getenv (dst)))
-	  return dst;				/* Can't translate */
-
-	/* should we jump to the beginning of this procedure?
-	   Good points: allows us to use logical names that xlate
-	   to Unix names,
-	   Bad points: can be a problem if we just translated to a device
-	   name...
-	   For now, I'll punt and always expect VMS names, and hope for
-	   the best! */
-
-	slen = strlen (src) - 1;
-	if (src[slen] != FN_C_AFTER_DIR && src[slen] != FN_C_AFTER_DIR_2)
-	{					/* no recursion here! */
-	  VOID(strmov(dst, src));
-	  return(dst);
-	}
-      }
-      else
-      {						/* not a directory spec */
-	VOID(strmov(dst, src));
-	return(dst);
-      }
-    }
-
-    bracket = src[slen];			/* End char */
-    if (!(ptr = strchr (src, bracket - 2)))
-    {						/* no opening bracket */
-      VOID(strmov (dst, src));
-      return dst;
-    }
-    if (!(rptr = strrchr (src, '.')))
-      rptr = ptr;
-    slen = rptr - src;
-    VOID(strmake (dst, src, slen));
-
-    if (*rptr == '.')
-    {						/* Put bracket and add */
-      dst[slen++] = bracket;			/* (rptr+1) after this */
-    }
-    else
-    {
-      /* If we have the top-level of a rooted directory (i.e. xx:[000000]),
-	 then translate the device and recurse. */
-
-      if (dst[slen - 1] == ':'
-	  && dst[slen - 2] != ':' 	/* skip decnet nodes */
-	  && strcmp(src + slen, "[000000]") == 0)
-      {
-	dst[slen - 1] = '\0';
-	if ((ptr = getenv (dst))
-	    && (rlen = strlen (ptr) - 1) > 0
-	    && (ptr[rlen] == FN_C_AFTER_DIR || ptr[rlen] == FN_C_AFTER_DIR_2)
-	    && ptr[rlen - 1] == '.')
-	{
-	  VOID(strmov(esa,ptr));
-	  esa[rlen - 1] = FN_C_AFTER_DIR;
-	  esa[rlen] = '\0';
-	  return (directory_file_name (dst, esa));
-	}
-	else
-	  dst[slen - 1] = ':';
-      }
-      VOID(strmov(dst+slen,"[000000]"));
-      slen += 8;
-    }
-    VOID(strmov(strmov(dst+slen,rptr+1)-1,".DIR.1"));
-    return dst;
-  }
-  VOID(strmov(dst, src));
-  if (dst[slen] == '/' && slen > 1)
-    dst[slen] = 0;
-  return dst;
-#endif	/* VMS */
 } /* directory_file_name */
 
 #elif defined(WIN32)

$ rename my_lib.c my_lib.c
$ set default mysql_root:[mysys]
$ copy my_lock.c my_lock.c$o
$ gpatch -u
--- my_lock.c$o	Fri Jun 11 21:59:23 2004
+++ my_lock.c	Fri Jun 11 21:59:24 2004
@@ -50,9 +50,6 @@
   DBUG_ENTER("my_lock");
   DBUG_PRINT("my",("Fd: %d  Op: %d  start: %ld  Length: %ld  MyFlags: %d",
 		   fd,locktype,(long) start,(long) length,MyFlags));
-#ifdef VMS
-  DBUG_RETURN(0);
-#else
   if (my_disable_locking)
     DBUG_RETURN(0);
 
@@ -164,5 +161,4 @@
   }
   DBUG_PRINT("error",("my_errno: %d (%d)",my_errno,errno));
   DBUG_RETURN(-1);
-#endif	/* ! VMS */
 } /* my_lock */

$ rename my_lock.c my_lock.c
$ set default mysql_root:[pstack]
$ copy linuxthreads.c linuxthreads.c$o
$ gpatch -u
--- linuxthreads.c$o	Fri Jun 11 21:59:24 2004
+++ linuxthreads.c	Fri Jun 11 21:59:24 2004
@@ -12,9 +12,22 @@
 #include	<stdio.h>
 #include	<unistd.h>
 #include	<signal.h>
+
+#ifdef __VMS
+#ifdef HAVE_SCHED_H
 #include	<sched.h>
+#endif
+#else
+#include	<sched.h>
+#endif
 
+#ifdef __VMS
+#ifdef HAVE_LINUXTHREADS
+#include	"linuxthreads.h"
+#endif
+#else
 #include	"linuxthreads.h"
+#endif
 
 #define AT_INT(intval)	*((int32_t*)(intval))
 

$ rename linuxthreads.c linuxthreads.c
$ set default mysql_root:[pstack]
$ copy pstack.c pstack.c$o
$ gpatch -u
--- pstack.c$o	Fri Jun 11 21:59:24 2004
+++ pstack.c	Fri Jun 11 21:59:24 2004
@@ -42,16 +42,36 @@
    Thanks 
 */
 
+#ifdef __VMS
+ typedef unsigned int u_int32_t;
+ #include <vmstypes.h>
+#endif
+
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <sys/wait.h>
+#ifdef __VMS
+#ifdef HAVE_SYS_PTRACE_H
+#include <sys/ptrace.h>
+#endif
+#else
 #include <sys/ptrace.h>
 #include <asm/ptrace.h>
+#endif
 
 #include <assert.h>
 #include <fcntl.h>
+#ifdef __VMS
+#ifdef HAVE_LINK_H
+#include <link.h>
+#endif
+#ifdef HAVE_MALLOC_H
+#include <malloc.h>
+#endif
+#else
 #include <link.h>
 #include <malloc.h>
+#endif
 #include <string.h>
 #include <stdarg.h>
 #include <unistd.h>

$ rename pstack.c pstack.c
$ set default mysql_root:[readline]
$ copy rltty.h rltty.h$o
$ gpatch -u
--- rltty.h$o	Fri Jun 11 21:59:25 2004
+++ rltty.h	Fri Jun 11 21:59:25 2004
@@ -39,7 +39,13 @@
 
 /* Other (BSD) machines use sgtty. */
 #if defined (NEW_TTY_DRIVER)
+#ifdef __VMS
+#ifdef HAVE_SGTTY_H
+#  include <sgtty.h>
+#endif
+#else
 #  include <sgtty.h>
+#endif
 #endif
 
 #include "rlwinsize.h"

$ rename rltty.h rltty.h
$ set default mysql_root:[sql]
$ copy field.cc field.cc$o
$ gpatch -u
--- field.cc$o	Fri Jun 11 21:59:25 2004
+++ field.cc	Mon Jun 14 22:13:32 2004
@@ -40,6 +40,9 @@
 #ifdef HAVE_FCONVERT
 #include <floatingpoint.h>
 #endif
+#ifdef __VMS
+#  include <stdio.h>
+#endif
 
 // Maximum allowed exponent value for converting string to decimal
 #define MAX_EXPONENT 1024
@@ -4959,7 +4962,14 @@
   case FIELD_TYPE_ENUM: abort(); return 0;	// This shouldn't happen
   default: return 0;
   }
+#ifdef __VMS
+#pragma message save
+#pragma message disable (CODEUNREACHABLE)
+#endif
   return 0;					// This shouldn't happen
+#ifdef __VMS
+#pragma message restore
+#endif
 }
 
 

$ rename field.cc field.cc
$ set default mysql_root:[sql]
$ copy ha_innodb.cc ha_innodb.cc$o
$ gpatch -u
--- ha_innodb.cc$o	Wed Jun 16 08:11:22 2004
+++ ha_innodb.cc	Wed Jun 16 08:14:57 2004
@@ -48,6 +48,28 @@
 
 /* Include necessary InnoDB headers */
 extern "C" {
+#if defined(__VMS) && defined(__ia64)
+/* Temporary fix for a compiler bug not currently fixed */
+#include "[-.INNOBASE.INCLUDE]univ.i"
+#include "[-.INNOBASE.INCLUDE]os0file.h"
+#include "[-.INNOBASE.INCLUDE]os0thread.h"
+#include "[-.INNOBASE.INCLUDE]srv0start.h"
+#include "[-.INNOBASE.INCLUDE]srv0srv.h"
+#include "[-.INNOBASE.INCLUDE]trx0roll.h"
+#include "[-.INNOBASE.INCLUDE]trx0trx.h"
+#include "[-.INNOBASE.INCLUDE]trx0sys.h"
+#include "[-.INNOBASE.INCLUDE]row0ins.h"
+#include "[-.INNOBASE.INCLUDE]row0mysql.h"
+#include "[-.INNOBASE.INCLUDE]row0sel.h"
+#include "[-.INNOBASE.INCLUDE]row0upd.h"
+#include "[-.INNOBASE.INCLUDE]log0log.h"
+#include "[-.INNOBASE.INCLUDE]lock0lock.h"
+#include "[-.INNOBASE.INCLUDE]dict0crea.h"
+#include "[-.INNOBASE.INCLUDE]btr0cur.h"
+#include "[-.INNOBASE.INCLUDE]btr0btr.h"
+#include "[-.INNOBASE.INCLUDE]fsp0fsp.h"
+#include "[-.INNOBASE.INCLUDE]sync0sync.h"
+#else
 #include "../innobase/include/univ.i"
 #include "../innobase/include/os0file.h"
 #include "../innobase/include/os0thread.h"
@@ -67,6 +89,7 @@
 #include "../innobase/include/btr0btr.h"
 #include "../innobase/include/fsp0fsp.h"
 #include "../innobase/include/sync0sync.h"
+#endif
 }
 
 #define HA_INNOBASE_ROWS_IN_TABLE 10000 /* to get optimization right */

$ rename ha_innodb.cc ha_innodb.cc
$ set default mysql_root:[sql]
$ copy mysqld.cc mysqld.cc$o
$ gpatch -u
--- mysqld.cc$o	Fri Jun 11 21:59:26 2004
+++ mysqld.cc	Fri Jun 11 21:59:26 2004
@@ -1097,7 +1097,7 @@
 
 static void set_root(const char *path)
 {
-#if !defined(__WIN__) && !defined(__EMX__) && !defined(OS2) && !defined(__NETWARE__)
+#if !defined(__WIN__) && !defined(__EMX__) && !defined(OS2) && !defined(__NETWARE__) && !defined(__VMS)
   if (chroot(path) == -1)
   {
     sql_perror("chroot");
@@ -1835,7 +1835,14 @@
       break;					/* purecov: tested */
     }
   }
-  return(0);					/* purecov: deadcode */
+#ifdef __VMS
+#pragma message save
+#pragma message disable (CODEUNREACHABLE)
+#endif
+  return(0);                                    /* purecov: deadcode */
+#ifdef __VMS
+#pragma message restore
+#endif
 }
 
 static void check_data_home(const char *path)

$ rename mysqld.cc mysqld.cc
$ set default mysql_root:[sql]
$ copy mysql_priv.h mysql_priv.h$o
$ gpatch -u
--- mysql_priv.h$o	Fri Jun 11 21:59:26 2004
+++ mysql_priv.h	Fri Jun 11 21:59:27 2004
@@ -247,7 +247,11 @@
 
 #define portable_sizeof_char_ptr 8
 
+#ifdef __VMS
+#define tmp_file_prefix "_sql"			/* Prefix for tmp tables */
+#else
 #define tmp_file_prefix "#sql"			/* Prefix for tmp tables */
+#endif
 #define tmp_file_prefix_length 4
 
 /* Flags for calc_week() function.  */

$ rename mysql_priv.h mysql_priv.h
$ set default mysql_root:[sql]
$ copy net_serv.cc net_serv.cc$o
$ gpatch -u
--- net_serv.cc$o	Fri Jun 11 21:59:27 2004
+++ net_serv.cc	Fri Jun 11 21:59:27 2004
@@ -78,7 +78,11 @@
 #endif
 
 #define TEST_BLOCKING		8
+#ifdef __VMS
+#define MAX_PACKET_LENGTH (255L*255L)
+#else
 #define MAX_PACKET_LENGTH (256L*256L*256L-1)
+#endif
 
 static my_bool net_write_buff(NET *net,const char *packet,ulong len);
 
@@ -924,7 +928,14 @@
     net->read_pos[len]=0;		/* Safeguard for mysql_use_result */
   }
 #endif /* HAVE_COMPRESS */
+#ifdef __VMS
+#pragma message save
+#pragma message disable (CODEUNREACHABLE)
+#endif
   return len;
+#ifdef __VMS
+#pragma message restore
+#endif
 }
 
 bool net_request_file(NET* net, const char* fname)

$ rename net_serv.cc net_serv.cc
$ set default mysql_root:[vio]
$ copy vio.c vio.c$o
$ gpatch -u
--- vio.c$o	Fri Jun 11 21:59:27 2004
+++ vio.c	Fri Jun 11 21:59:28 2004
@@ -51,7 +51,11 @@
     vio->viokeepalive	=vio_ssl_keepalive;
     vio->should_retry	=vio_ssl_should_retry;
     vio->vioclose	=vio_ssl_close;
+#ifdef __VMS
+    vio->peer_addr	=(my_bool (*)(Vio*, char*, uint16*))vio_ssl_peer_addr;
+#else
     vio->peer_addr	=vio_ssl_peer_addr;
+#endif
     vio->in_addr	=vio_ssl_in_addr;
     vio->vioblocking	=vio_ssl_blocking;
     vio->is_blocking	=vio_is_blocking;

$ rename vio.c vio.c
$ set default mysql_root:[vio]
$ copy viosocket.c viosocket.c$o
$ gpatch -u
--- viosocket.c$o	Fri Jun 11 21:59:28 2004
+++ viosocket.c	Fri Jun 11 21:59:28 2004
@@ -55,6 +55,8 @@
     DBUG_RETURN(length);
   }
   r = recv(vio->sd, buf, size,0);
+#elif defined(__VMS)
+  r = recv(vio->sd, buf, size,0);
 #else
   errno=0;					/* For linux */
   r = read(vio->sd, buf, size);
@@ -83,6 +85,8 @@
       DBUG_RETURN(-1);
     DBUG_RETURN(length);
   }
+  r = send(vio->sd, buf, size, 0);
+#elif defined(__VMS)
   r = send(vio->sd, buf, size, 0);
 #else
   r = write(vio->sd, buf, size);

$ rename viosocket.c viosocket.c
$ set default mysql_root:[vms.mysql]
