import os.path, string, posix, vms.crtl, sys

arg1 = sys.argv[1].lower()

if not arg1 in ['server','client']:
    sys.exit(44)

BUILD_SERVER = (arg1 == 'server')

#
#
IDIR = ['mysql_root:[include]']

DefineFlags = "/define=(_LARGEFILE,DBUG_OFF,'CLIENT_OR_SERVER')"

def new_file(fg, dirname):
    global IDIR, BUILD_SERVER, DefineFlags
    bname = os.path.basename(dirname)
    if BUILD_SERVER:
        nstr = '_srv'
    else:
        nstr = '_cli'
#    fn = 'mysql_root:[vms.mysql.scripts]compil_' + bname + nstr + '.mms'
    fn = 'mysql_root:[vms.mysql.scripts]compil_' + bname + '.mms'
#    print 'create/dir mysql_root:[vms.mysql.o_alpha.%s]' % bname
    print >> fg, '$ create/dir mysql_root:[vms.mysql.o_alpha.%s]' % bname
    print >> fg, '$ set default mysql_root:[vms.mysql.o_alpha.%s]' % bname
    print >> fg, '$ mms/description=' + fn
    f = open(fn, 'w')
    print >> f, '#'
    print >> f, '# Generated by genbuild_mms.py'
    print >> f, '#'
    print >> f, 'libname = MYSQL_ROOT:[VMS.MYSQL]%s.OLB' % bname
#    print 'library/create/object MYSQL_ROOT:[VMS.MYSQL]%s.OLB' % bname
    print >> f, '#'
    print >> f, 'idir = %s, \\' % IDIR[0]
    for i in range(1, len(IDIR)):
        print >> f, "\t%s,\\" % IDIR[i]
    print >> f, "\tsys$disk:[]"
    print >> f, '#'
    print >> f, 'odir = mysql_root:[vms.mysql.o_alpha.%s]' % bname
    print >> f, '#'
    print >> f, 'iflags = /include=(mysql_include)'
    print >> f, 'oflags = /object=mysql_obj/mms=file=mysql_obj'
    print >> f, 'dflags = /optim' + DefineFlags
    print >> f, 'nflags = /name=(short,as_is)/float=ieee'
    print >> f, 'rflags = /repository=mysql_rep'
    print >> f, 'cflags = $(oflags) $(iflags) $(dflags) $(nflags) $(rflags)/warn=disable=PTRMISMATCH1'
    print >> f, 'cxxflags = $(oflags) $(iflags) $(dflags) $(rflags) $(nflags)'
    print >> f, '#'
    print >> f, '.first'
    print >> f, '    set process/parse=extend'
    print >> f, '    set default', vms.crtl.to_vms(dirname)
    print >> f, '    define mysql_include $(idir)'
    print >> f, '    define mysql_obj $(odir)'
    print >> f, '    CLIENT_OR_SERVER = f$trnlnm("MYSQL_CLIENT_OR_SERVER")'
    print >> f, '#'
    return f


def end_file(f):
    print >>f, '#'


def listRep(args, dirname, filenames):
    fg = args[0]
    accept = args[1]
    reject = args[2]
    first = 1
    vmsdirname = vms.crtl.to_vms(dirname)

    lstnames = []
    for fn in filenames:
        if fn in reject:
            continue
        if accept <> [] and not (fn in accept):
            continue
        if fn[-2:] == '.c':
            lstnames += [fn[:-2]]
        elif fn[-3:] == '.cc':
            lstnames += [fn[:-3]]

    for fn in filenames:
        if fn in reject:
            continue
        if accept <> [] and not (fn in accept):
            continue

        if first and (fn[-2:] == '.c' or fn[-3:] == '.cc'):
            first = 0
            fc = new_file(fg, dirname)
            print >> fc
#            print >> fc, 'compile : $(libname)(%s=%s.OBJ)' % (lstnames[0], lstnames[0]),
#            for x in lstnames[1:]:
#                print >> fc, ",\\\n\t$(libname)(%s=%s.OBJ)" % (x, x),
#            print >> fc
            print >> fc, 'compile : %s.OBJ' % lstnames[0],
            for x in lstnames[1:]:
                print >> fc, ",\\\n%s.OBJ" % x,
            print >> fc
            print >> fc, '\tshow time'
            print >> fc

        if fn[-2:] == '.c':
            fn = fn[:-2]
#            line = "$(libname)(%s=%s.OBJ) : %s.OBJ" % (fn, fn, fn)
#            print >> fc, line
#            line = "\t- library/replace $(libname) %s.OBJ" %fn
#            print >> fc, line
#            print >> fc
            line = "%s.OBJ : %s%s.c" % (fn, vmsdirname, fn)
            print >> fc, line
            print >> fc, "\t- cc $(cflags) %s.c" % fn
#            line = "\t- library/replace $(libname) %s.OBJ" %fn
            print >> fc, line
            print >> fc
        elif fn[-3:] == '.cc':
            fn = fn[:-3]
#            line = "$(libname)(%s=%s.OBJ) : %s.OBJ" % (fn, fn, fn)
#            print >> fc, line
#            line = "\t- library/replace $(libname) %s.OBJ" %fn
#            print >> fc, line
#            print >> fc
            line = "%s.OBJ : %s%s.cc" % (fn, vmsdirname, fn)
            print >> fc, line
            print >> fc, "\t- cxx $(cxxflags) %s.cc" % fn
#            line = "\t- library/replace $(libname) %s.OBJ" %fn
            print >> fc, line
            print >> fc
    if first == 0:
        end_file(fc)
        fc.close()


def genbuild(f, dir, accept=[], reject=[]):
    os.path.walk(dir, listRep, (f, accept, reject))
    cmd = 'set default mysql_root:[vms.mysql.scripts]'


f = open('mysql_root:[vms.mysql.scripts]build_all_mms.com','w')
print >> f, '$!'
print >> f, '$! Generated by genbuild_mms.py'
print >> f, '$!'
print >> f, '$ set default mysql_root:[vms.mysql.scripts]'
print >> f, '$'
print >> f, '$ @mysql_root:[vms.mysql]build_init'
#
IDIR = ['mysql_root:[include]']
fileslst = ['comp_err.c','isamlog.c','mysql_install.c', 'sort.c',
 'my_print_defaults.c','pack_isam.c','perror.c','replace.c',
 'resolveip.c','resolve_stack_dump.c','static.c','test1.c','test2.c','test3.c']
genbuild(f, '/mysql_root/isam',reject=fileslst)
#
IDIR = ['mysql_root:[include]' , 'mysql_root:[mysys]', 'libz']
fileslst = ['my_os2cond.c','my_os2dlfcn.c','my_os2file64.c','my_os2mutex.c',
            'my_os2thread.c','my_os2tls.c','my_os2dirsrch.c',
            'test_charset.c', 'mf_qsort.c', 'my_lock.c']
genbuild(f, '/mysql_root/mysys',reject=fileslst)
#
if not BUILD_SERVER:
    IDIR = ['mysql_root:[include]','mysql_root:[client]','mysql_root:[readline]',
            'mysql_root:[sql]', 'mysql_root:[regex]']
    fileslst =['log_event.cc']
    genbuild(f, '/mysql_root/client',reject=fileslst)
#
IDIR = ['mysql_root:[include]','mysql_root:[sql]','mysql_root:[regex]',
        'mysql_root:[innobase.include]']

if BUILD_SERVER:
    fileslst=['gen_lex_hash.cc','mysqld.cc']
    genbuild(f, '/mysql_root/sql',reject=fileslst)
else:
    fileslst=['my_lock.c', 'net_serv.cc']
    genbuild(f, '/mysql_root/sql',accept=fileslst)
#
if not BUILD_SERVER:
    IDIR = ['mysql_root:[include]','mysql_root:[libmysql]']
    fileslst =['errmsg.c','manager.c', 'libmysql.c','password.c']
    genbuild(f, '/mysql_root/libmysql',accept=fileslst)
#
IDIR = ['mysql_root:[include]','mysql_root:[vio]']
fileslst = ['test-sslserver.c','test-ssl.c','test-sslclient.c']
genbuild(f, '/mysql_root/vio',reject=fileslst)
#
IDIR = ['mysql_root:[include]','mysql_root:[strings]','mysql_root:[libmysql]']
fileslst = ['ctype_autoconf.c','conf_to_src.c','ctype_extra_sources.c',
            'strto.c']
genbuild(f, '/mysql_root/strings',reject=fileslst)
#
IDIR = ['mysql_root:[include]','mysql_root:[myisammrg]','mysql_root:[merge]']
fileslst = ['']
genbuild(f, '/mysql_root/myisammrg',reject=fileslst)
#
IDIR = ['mysql_root:[include]','mysql_root:[myisam]','mysql_root:[isam]']
if BUILD_SERVER:
    fileslst = ['mi_test1.c','mi_test2.c','mi_test3.c', 'myisamchk.c',
                'myisamlog.c','myisampack.c', 'myisam_ftdump.c']
    genbuild(f, '/mysql_root/myisam',reject=fileslst)
else:
    genbuild(f, '/mysql_root/myisam')

#
IDIR = ['mysql_root:[include]','mysql_root:[merge]','mysql_root:[isam]']
fileslst = ['mrg_static.c']
genbuild(f, '/mysql_root/merge',reject=fileslst)
#
IDIR = ['mysql_root:[include]']
fileslst = ['hp_test1.c','hp_test2.c']
genbuild(f, '/mysql_root/heap',reject=fileslst)
#
IDIR = ['mysql_root:[include]','mysql_root:[regex]']
fileslst = ['regerror.c','regcomp.c','regexec.c','regfree.c','reginit.c']
genbuild(f, '/mysql_root/regex',accept=fileslst)
#
IDIR = ['mysql_root:[include]']
fileslst = ['example1.c','example2.c','example3.c','main.c','dbug_analyze.c']
genbuild(f, '/mysql_root/dbug',reject=fileslst)
#
print >> f, '$'
print >> f, '$ set default mysql_root:[vms.mysql.scripts]'
print >> f, '$'
print >> f, '$ @mysql_root:[vms.mysql]build_end'
f.close
