#define __NEW_STARLET
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>

#include <eobjrecdef.h>
#include <ssdef.h>
#include <stsdef.h>
#include <eobjrecdef.h>
#include <lib$routines.h>

#include <client_priv.h>
#include <mysql_version.h>

#include <upcase_names.h>

/*
 * define the Module Header Subrecords.
 * See Table B-4 of the OpenVMS Linker Utility Manual
 */
# define        EMH$C_MHD       0
# define        EMH$C_LNM       1
# define        EMH$C_SRC       2
# define        EMH$C_TTL       3
# define        EMH$C_CPR       4
# define        EMH$C_MTC       5
# define        EMH$C_GTX       6
/*
 * Define the types of GSD Subrecords
 * See Table B-5 of the OpenVMS Linker Utility Manual
 */
# define	EGSD$C_PSC	0
# define	EGSD$C_SYM	1
# define	EGSD$C_IDC	2
# define	EGSD$C_SPSC	5
# define	EGSD$C_SYMV	6
# define	EGSD$C_SYMM	7
# define	EGSD$C_SYMG	8
/*
 * Define the field EGSY$W_FLAGS bit offset 0 to 6.
 * See Page B-19 of the OpenVMS Linker Utility Manual
 */
# define	EGSY$V_WEAK	0
# define	EGSY$V_DEF	1
# define	EGSY$V_UNI	2
# define	EGSY$V_REL	3
# define	EGSY$V_COMM	4
# define	EGSY$V_VECEP	5
# define	EGSY$V_NORM	6

/*
 * Define Macros here
 */
#define sizeof_ascic(chr) ((chr)+sizeof(char))

typedef unsigned char** envbuf_t;

typedef struct sdadefs objdef_t;

/*
 * define missing types which are not defined
 * in eobjrecdef.h.
 * First describe a moduler header record type.
 * This will be used to obtain the module name.
 */
typedef struct {
     unsigned int emh$l_arch1;
     unsigned int emh$l_arch2;
     unsigned int emh$l_recsiz;
     unsigned char emh$b_namlng;
} eobj$header_t;

#pragma nostandard
#pragma member_alignment save
#pragma nomember_alignment
/*
 * Describe the layout of the GSD subrecord type.
 * Note that we are mostly interested in the Global
 * Symbol Definition for data and routines (EGSD$C_SYM
 * subtype).
 */
typedef struct {
     unsigned short egsy$w_gsdtyp;
     unsigned short egsy$w_size;
     union{
          unsigned egsy$b_other;
          struct{
		unsigned char egsy$b_datyp;
		unsigned char egsy$b_temp;
                union {
		     unsigned short egsy$w_flagshort;
		     struct{
			unsigned char egsy$v_weak:1;
			unsigned char egsy$v_def:1;
			unsigned char egsy$v_uni:1;
			unsigned char egsy$v_rel:1;
			unsigned char egsy$v_comm:1;
			unsigned char egsy$v_vecep:1;
			unsigned char egsy$v_norm:1;
			unsigned int egsy$reserved:9;
                     } egsy$w_overlay;
		} egsy$w_flags;
                union {
                    struct {
  		        unsigned int esdf$l_value;
		        unsigned int esdf$l_reserved_1;
		        unsigned int esdf$l_code_address;
		        unsigned int esdf$l_reserved_2;
                        unsigned int esdf$l_ca_psindx;
                        unsigned int esdf$l_psindx;
		        unsigned char esdf$b_namlng;
                    } egsy$gsd_def_struct; 
	            unsigned char esrf$b_namlng; 
               } egsy$gsd_nam_overlay;
          }egsy$gsd_symm_overlay;
     }egps$gsd_overlay;
} egps$gsd_t;
#pragma member_alignment restore

#define egps$b_datatyp egps$gsd_overlay.egsy$gsd_symm_overlay.egps$b_datatyp
#define egsy$w_flagshort \
egps$gsd_overlay.egsy$gsd_symm_overlay.egsy$w_flags.egsy$w_flagshort
#define egsy$v_weak \
egps$gsd_overlay.egsy$gsd_symm_overlay.egsy$w_flags.egsy$w_overlay.egsy$v_weak
#define egsy$v_def \
egps$gsd_overlay.egsy$gsd_symm_overlay.egsy$w_flags.egsy$w_overlay.egsy$v_def
#define egsy$v_uni \
egps$gsd_overlay.egsy$gsd_symm_overlay.egsy$w_flags.egsy$w_overlay.egsy$v_uni
#define egsy$v_rel \
egps$gsd_overlay.egsy$gsd_symm_overlay.egsy$w_flags.egsy$w_overlay.egsy$v_rel
#define egsy$v_comm \
egps$gsd_overlay.egsy$gsd_symm_overlay.egsy$w_flags.egsy$w_overlay.egsy$v_comm
#define egsy$v_vecep \
egps$gsd_overlay.egsy$gsd_symm_overlay.egsy$w_flags.egsy$w_overlay.egsy$v_vecep
#define egsy$v_norm \
egps$gsd_overlay.egsy$gsd_symm_overlay.egsy$w_flags.egsy$w_overlay.egsy$v_norm
#define esdf$l_value egps$gsd_overlay.egsy$gsd_symm_overlay.esdf$l_value
#define esdf$l_code_address egps$gsd_overlay.egsy$gsd_symm_overlay.esdf$l_code_address
#define esdf$l_psindx egps$gsd_overlay.egsy$gsd_symm_overlay.esdf$l_psindx
#define esdf$l_ca_psindx egps$gsd_overlay.egsy$gsd_symm_overlay.esdf$l_ca_psindx
#define esdf$b_namlng \
  egps$gsd_overlay.egsy$gsd_symm_overlay.egsy$gsd_nam_overlay.egsy$gsd_def_struct.esdf$b_namlng
#define esrf$b_namlng \
  egps$gsd_overlay.egsy$gsd_symm_overlay.egsy$gsd_nam_overlay.esrf$b_namlng
#pragma standard


static MYSQL	mysql_connection;
static my_bool	opt_compress=0, tty_password=0;
static char	*opt_password=0, *current_user=0,
		*current_host=0, *current_db=0, *current_filename=0;
static uint     opt_mysql_port=0;
static my_string opt_mysql_unix_port=0;
#include <sslopt-vars.h>

static struct my_option my_long_options[] =
{
  {"compress", 'C', "Use compression in server/client protocol.",
   (gptr*) &opt_compress, (gptr*) &opt_compress, 0, GET_BOOL, NO_ARG, 0, 0, 0,
   0, 0, 0},
  {"host", 'h', "Connect to host.", (gptr*) &current_host,
   (gptr*) &current_host, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
  {"password", 'p',
   "Password to use when connecting to server. If password is not given it's asked from the tty.",
   0, 0, 0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
  {"port", 'P', "Port number to use for connection.", (gptr*) &opt_mysql_port,
   (gptr*) &opt_mysql_port, 0, GET_UINT, REQUIRED_ARG, MYSQL_PORT, 0, 0, 0, 0,
   0},
  {"socket", 'S', "Socket file to use for connection.",
   (gptr*) &opt_mysql_unix_port, (gptr*) &opt_mysql_unix_port, 0, GET_STR,
   REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
#include <sslopt-longopts.h>
  {"user", 'u', "User for login if not current user.", (gptr*) &current_user,
   (gptr*) &current_user, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
  { 0, 0, 0, 0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0}
};
static const char *load_default_groups[]= { "loadobject","client",0 };



static my_bool
get_one_option(int optid, const struct my_option *opt __attribute__((unused)),
	       char *argument)
{
  switch(optid) {
  case 'p':
    if (argument)
    {
      char *start=argument;
      my_free(opt_password,MYF(MY_ALLOW_ZERO_PTR));
      opt_password=my_strdup(argument,MYF(MY_FAE));
      while (*argument) *argument++= 'x';		/* Destroy argument */
      if (*start)
	start[1]=0;				/* Cut length of argument */
    }
    else
      tty_password= 1;
    break;
  case '#':
    DBUG_PUSH(argument ? argument : "d:t:o");
    break;
#include <sslopt-case.h>
  }
  return 0;
}

static int get_options(int *argc, char ***argv)
{
  int ho_error;

  if ((ho_error=handle_options(argc, argv, my_long_options, get_one_option)))
    exit(ho_error);

  current_db= *((*argv)++);
  current_filename= *((*argv)++);
  (*argc)--;
  if (tty_password)
    opt_password=get_tty_password(NullS);
  return(0);
}

static void safe_exit(int error, MYSQL *mysql)
{
  if (mysql)
    mysql_close(mysql);
  exit(error);
}

static void db_error_with_table(MYSQL *mysql, char *table)
{
  my_printf_error(0,"Error: %s, when using table: %s",
		  MYF(0), mysql_error(mysql), table);
  safe_exit(1, mysql);
}

static void db_error(MYSQL *mysql)
{
  my_printf_error(0,"Error: %s", MYF(0), mysql_error(mysql));
  safe_exit(1, mysql);
}


static MYSQL *db_connect(char *host, char *database, char *user, char *passwd)
{
  MYSQL *mysql;
  mysql_init(&mysql_connection);
  if (opt_compress)
    mysql_options(&mysql_connection,MYSQL_OPT_COMPRESS,NullS);
#ifdef HAVE_OPENSSL
  if (opt_use_ssl)
    mysql_ssl_set(&mysql_connection, opt_ssl_key, opt_ssl_cert, opt_ssl_ca,
		  opt_ssl_capath, opt_ssl_cipher);
#endif
  if (!(mysql= mysql_real_connect(&mysql_connection,host,user,passwd,
				 database,opt_mysql_port,opt_mysql_unix_port,
				 0)))
  {
    db_error(&mysql_connection);
  }
  if (mysql_select_db(mysql, database))
  {
    db_error(&mysql_connection);
  }
  return mysql;
}

static void db_disconnect(char *host, MYSQL *mysql)
{
  mysql_close(mysql);
}

void
locate_globalnames(objdef_t *objdef_p, int size, MYSQL* mysql, my_ulonglong object_id) {
    unsigned char *cp;
    egps$gsd_t *egps$gsd;
    unsigned int i;
    unsigned char symbol_name[EOBJ$C_MAXRECSIZ+sizeof(int)];
    char sql_statement[1024];

    while (size > 0) {
        int procedure;
        int definition;
        int weak;

        egps$gsd = (egps$gsd_t *)objdef_p;
        /*
         * It happens that the Compaq ALPHA C compiler generates a
         * a GSD subrecord with a zero length to mark the end of the
         * subrecords, although the analysis did not come to all the
         * GSD record (size == 0).
         * So if there is a null length GSD subrecord, exit while loop.
         */
        if (egps$gsd->egsy$w_size == 0) break;
        if (egps$gsd->egsy$w_gsdtyp == EGSD$C_SYM) {
            /*
             * We are only dealing with EGSD$C_SYM subrecords because this
             * kind of subrecord contains both procedure definitions/references
             * and data definition/references.
             */
            if (egps$gsd->egsy$v_def)
                cp = &egps$gsd->esdf$b_namlng;
            else
                cp = &egps$gsd->esrf$b_namlng;
            definition = egps$gsd->egsy$v_def;
            weak = egps$gsd->egsy$v_weak;

            /*
             * Store the global ASCIC name.
             */
	    memcpy(symbol_name,cp + 1,sizeof_ascic(*cp));
            symbol_name[*cp] = '\0';
            /*
             * If the bit NORM is set in the flags, it mean
             * that the global symbol is a procedure. If clear
             * it means it is data.
             */
            procedure = egps$gsd->egsy$v_norm;
            /*
             * 
             */
            if (strlen((char *)symbol_name) > 0) {
#if 0
	        printf("%d %d %d %d %s\n", 
		       egps$gsd->egsy$w_flagshort, definition, weak, 
		       procedure, symbol_name);
#endif
                sprintf(sql_statement,
                        "INSERT INTO %s VALUES (%llu, '%s', '%s', '%s')",
                        definition ? "vmsmod_db.symboldef" : "vmsmod_db.symbolref",
			object_id,
			symbol_name,
			procedure ? "Y" : "N",
			weak ? "Y" : "N");
		if (mysql_query(mysql, sql_statement)) {
		    db_error_with_table(mysql, definition ? "vmsmod_db.symboldef" 
						          : "vmsmod_db.symbolref");
		}
            }
        }
        /*
         * Adjust the pointer to the next subrecord, decrease the number
         * of remaining bytes.
         */
        cp = (unsigned char *)egps$gsd + egps$gsd->egsy$w_size;
        size = size - egps$gsd->egsy$w_size;
        if (size <= 8) break;
        objdef_p = (objdef_t *)cp;
    }/* end while */
    return;
}

main(int argc, char *argv[]) {
    int         f;
    int         len;
    char        buf[EOBJ$C_MAXRECSIZ];
    EOBJRECDEF* object = (EOBJRECDEF *)buf;
    objdef_t*   objdef_p;
    char **argv_to_free;
    MYSQL *mysql=0;
    MY_INIT(argv[0]);
    char sql_statement[1024];
    MYSQL_RES *result;
    MYSQL_ROW row;
    unsigned long *lengths;
    my_ulonglong object_id;

    load_defaults("my",load_default_groups,&argc,&argv);
    /* argv is changed in the program */
    argv_to_free= argv;
    if (get_options(&argc, &argv)) {
        free_defaults(argv_to_free);
        return(SS$_ABORT);
    }
    if (!(mysql= db_connect(current_host,current_db,current_user,opt_password))){
        free_defaults(argv_to_free);
        return(SS$_ABORT); /* purecov: deadcode */
    }

    if (mysql_query(mysql, "BEGIN WORK")) {
        db_error(mysql);
    }

    sprintf(sql_statement,
            "SELECT object_id from vmsmod_db.object WHERE file_name='%s'",
            current_filename);

    if (mysql_query(mysql, sql_statement)) {
        db_error_with_table(mysql, "vmsmod_db.object");
    }

    result = mysql_store_result(mysql);
    if (result && mysql_num_rows(result)) {
        char str[20];
        row = mysql_fetch_row(result);
        lengths = mysql_fetch_lengths(result);
        strncpy(str, row[0], lengths[0]);
        str[lengths[0]] = '\0';
        object_id = atol(str);
        mysql_free_result(result);
        sprintf(sql_statement,
                "DELETE FROM vmsmod_db.symbolref WHERE object_id=%llu", object_id);
        if (mysql_query(mysql, sql_statement)) {
            db_error_with_table(mysql, "vmsmod_db.symbolref");
        }
        sprintf(sql_statement,
                "DELETE FROM vmsmod_db.symbolref WHERE object_id=%llu", object_id);
        if (mysql_query(mysql, sql_statement)) {
            db_error_with_table(mysql, "vmsmod_db.symbolref");
        }
    } else {
        mysql_free_result(result);
        sprintf(sql_statement,
                "INSERT INTO vmsmod_db.object(file_name) VALUES ('%s')",
                current_filename);
        if (mysql_query(mysql, sql_statement)) {
           db_error_with_table(mysql, "vmsmod_db.object");
        }
        object_id = mysql_insert_id(mysql);
    }

    f = open(current_filename, O_RDONLY, 0777);

    while (len = read(f, buf, sizeof(buf))) {
        if (object->eobj$w_rectyp == EOBJ$C_EGSD) {
            objdef_p = (objdef_t*)&object->eobj$w_mhd_recsz;
            locate_globalnames (objdef_p, len, mysql, object_id);
        }
    }

    if (mysql_query(mysql, "COMMIT")) {
        db_error(mysql);
    }

    close(f);
    db_disconnect(current_host, mysql);
    my_free(opt_password,MYF(MY_ALLOW_ZERO_PTR));
    free_defaults(argv_to_free);
    my_end(0);
}

