#define __NEW_STARLET
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>

#include <eobjrecdef.h>
#include <ssdef.h>
#include <stsdef.h>
#include <eobjrecdef.h>
#include <lib$routines.h>

#include <client_priv.h>
#include <mysql_version.h>

#include <upcase_names.h>


#pragma nostandard
#pragma member_alignment save
#pragma nomember_alignment
typedef struct {
    char b_symnam[31]; 
    char b_fullnam[255]; 
} RepositoryRecord;
#pragma member_alignment restore

#pragma standard


static MYSQL	mysql_connection;
static my_bool	opt_compress=0, tty_password=0;
static char	*opt_password=0, *current_user=0,
		*current_host=0, *current_db=0, *current_filename=0;
static uint     opt_mysql_port=0;
static my_string opt_mysql_unix_port=0;
#include <sslopt-vars.h>

static struct my_option my_long_options[] =
{
  {"compress", 'C', "Use compression in server/client protocol.",
   (gptr*) &opt_compress, (gptr*) &opt_compress, 0, GET_BOOL, NO_ARG, 0, 0, 0,
   0, 0, 0},
  {"host", 'h', "Connect to host.", (gptr*) &current_host,
   (gptr*) &current_host, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
  {"password", 'p',
   "Password to use when connecting to server. If password is not given it's asked from the tty.",
   0, 0, 0, GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
  {"port", 'P', "Port number to use for connection.", (gptr*) &opt_mysql_port,
   (gptr*) &opt_mysql_port, 0, GET_UINT, REQUIRED_ARG, MYSQL_PORT, 0, 0, 0, 0,
   0},
  {"socket", 'S', "Socket file to use for connection.",
   (gptr*) &opt_mysql_unix_port, (gptr*) &opt_mysql_unix_port, 0, GET_STR,
   REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
#include <sslopt-longopts.h>
  {"user", 'u', "User for login if not current user.", (gptr*) &current_user,
   (gptr*) &current_user, 0, GET_STR, REQUIRED_ARG, 0, 0, 0, 0, 0, 0},
  { 0, 0, 0, 0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0}
};
static const char *load_default_groups[]= { "loadobject","client",0 };



static my_bool
get_one_option(int optid, const struct my_option *opt __attribute__((unused)),
	       char *argument)
{
  switch(optid) {
  case 'p':
    if (argument)
    {
      char *start=argument;
      my_free(opt_password,MYF(MY_ALLOW_ZERO_PTR));
      opt_password=my_strdup(argument,MYF(MY_FAE));
      while (*argument) *argument++= 'x';		/* Destroy argument */
      if (*start)
	start[1]=0;				/* Cut length of argument */
    }
    else
      tty_password= 1;
    break;
  case '#':
    DBUG_PUSH(argument ? argument : "d:t:o");
    break;
#include <sslopt-case.h>
  }
  return 0;
}

static int get_options(int *argc, char ***argv)
{
  int ho_error;

  if ((ho_error=handle_options(argc, argv, my_long_options, get_one_option)))
    exit(ho_error);

  current_db= *((*argv)++);
  current_filename= *((*argv)++);
  (*argc)--;
  if (tty_password)
    opt_password=get_tty_password(NullS);
  return(0);
}

static void safe_exit(int error, MYSQL *mysql)
{
  if (mysql)
    mysql_close(mysql);
  exit(error);
}

static void db_error_with_table(MYSQL *mysql, char *table)
{
  my_printf_error(0,"Error: %s, when using table: %s",
		  MYF(0), mysql_error(mysql), table);
  safe_exit(1, mysql);
}

static void db_error(MYSQL *mysql)
{
  my_printf_error(0,"Error: %s", MYF(0), mysql_error(mysql));
  safe_exit(1, mysql);
}


static MYSQL *db_connect(char *host, char *database, char *user, char *passwd)
{
  MYSQL *mysql;
  mysql_init(&mysql_connection);
  if (opt_compress)
    mysql_options(&mysql_connection,MYSQL_OPT_COMPRESS,NullS);
#ifdef HAVE_OPENSSL
  if (opt_use_ssl)
    mysql_ssl_set(&mysql_connection, opt_ssl_key, opt_ssl_cert, opt_ssl_ca,
		  opt_ssl_capath, opt_ssl_cipher);
#endif
  if (!(mysql= mysql_real_connect(&mysql_connection,host,user,passwd,
				 database,opt_mysql_port,opt_mysql_unix_port,
				 0)))
  {
    db_error(&mysql_connection);
  }
  if (mysql_select_db(mysql, database))
  {
    db_error(&mysql_connection);
  }
  return mysql;
}

static void db_disconnect(char *host, MYSQL *mysql)
{
  mysql_close(mysql);
}

void
locate_globalnames(RepositoryRecord* rec, int reclen, MYSQL* mysql) {
    unsigned int i;
    char symbol_name[33];
    char full_name[256];
    char language[4];
    char sql_statement[1024];

    for (i = 0; (i < sizeof(rec->b_symnam)) && (rec->b_symnam[i] != ' '); ++i) {
	symbol_name[i] = rec->b_symnam[i];
    }
    symbol_name[i] = '\0';
    reclen -= sizeof(rec->b_symnam);
    strncpy(full_name, rec->b_fullnam, reclen);
    full_name[reclen] = '\0';

    sprintf(sql_statement, "INSERT INTO vmsmod_db.repository VALUES ('%s', '%s')",
	    symbol_name, full_name);
    if (mysql_query(mysql, sql_statement)) {
	db_error_with_table(mysql, "vmsmod_db.repository");
    }
    return;
}

main(int argc, char *argv[]) {
    int         f;
    int         len;
    char        buf[sizeof(RepositoryRecord)];
    RepositoryRecord* rec = (RepositoryRecord *)buf;
    char **argv_to_free;
    MYSQL *mysql=0;
    MY_INIT(argv[0]);

    load_defaults("my",load_default_groups,&argc,&argv);
    /* argv is changed in the program */
    argv_to_free= argv;
    if (get_options(&argc, &argv)) {
        free_defaults(argv_to_free);
        return(SS$_ABORT);
    }
    if (!(mysql= db_connect(current_host,current_db,current_user,opt_password))){
        free_defaults(argv_to_free);
        return(SS$_ABORT); /* purecov: deadcode */
    }

    if (mysql_query(mysql, "BEGIN WORK")) {
        db_error(mysql);
    }

    if (mysql_query(mysql, "DELETE FROM vmsmod_db.repository")) {
        db_error_with_table(mysql, "vmsmod_db.repository");
    }

    f = open(current_filename, O_RDONLY, 0777);

    while (len = read(f, buf, sizeof(buf))) {
	locate_globalnames(rec, len, mysql);
    }

    if (mysql_query(mysql, "COMMIT")) {
        db_error(mysql);
    }

    close(f);
    db_disconnect(current_host, mysql);
    my_free(opt_password,MYF(MY_ALLOW_ZERO_PTR));
    free_defaults(argv_to_free);
    my_end(0);
}

