$ mysql
  CREATE DATABASE IF NOT EXISTS mysql;
  CREATE DATABASE IF NOT EXISTS test;
  DROP TABLE IF EXISTS mysql.db;
  CREATE TABLE mysql.db (
  Host char(60) binary DEFAULT '' NOT NULL,
  Db char(64) binary DEFAULT '' NOT NULL,
  User char(16) binary DEFAULT '' NOT NULL,
  Select_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Insert_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Update_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Delete_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Create_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Drop_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Grant_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  References_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Index_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Alter_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Create_tmp_table_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Lock_tables_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  PRIMARY KEY Host (Host,Db,User),
  KEY User (User)
  )
  comment='Database privileges';

  INSERT INTO mysql.db VALUES ('%','test','','Y','Y','Y','Y','Y','Y','N','Y','Y','Y','Y','Y');
  INSERT INTO mysql.db VALUES ('%','test\_%','','Y','Y','Y','Y','Y','Y','N','Y','Y','Y','Y','Y');

  DROP TABLE IF EXISTS mysql.host;
  CREATE TABLE mysql.host (
  Host char(60) binary DEFAULT '' NOT NULL,
  Db char(64) binary DEFAULT '' NOT NULL,
  Select_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Insert_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Update_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Delete_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Create_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Drop_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Grant_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  References_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Index_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Alter_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Create_tmp_table_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  Lock_tables_priv enum('N','Y') DEFAULT 'N' NOT NULL,
  PRIMARY KEY Host (Host,Db)
   )
   comment='Host privileges;  Merged with database privileges';

 DROP TABLE IF EXISTS mysql.user;
 CREATE TABLE mysql.user (
 Host char(60) binary DEFAULT '' NOT NULL,
 User char(16) binary DEFAULT '' NOT NULL,
 Password char(16) binary DEFAULT '' NOT NULL,
 Select_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Insert_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Update_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Delete_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Create_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Drop_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Reload_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Shutdown_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Process_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 File_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Grant_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 References_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Index_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Alter_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Show_db_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Super_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Create_tmp_table_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Lock_tables_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Execute_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Repl_slave_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 Repl_client_priv enum('N','Y') DEFAULT 'N' NOT NULL,
 ssl_type enum('','ANY','X509', 'SPECIFIED') DEFAULT '' NOT NULL,
 ssl_cipher BLOB NOT NULL,
 x509_issuer BLOB NOT NULL,
 x509_subject BLOB NOT NULL,
 max_questions int(11) unsigned DEFAULT 0  NOT NULL,
 max_updates int(11) unsigned DEFAULT 0  NOT NULL,
 max_connections int(11) unsigned DEFAULT 0  NOT NULL,
 PRIMARY KEY Host (Host,User)
 )
 comment='Users and global privileges';

 INSERT INTO mysql.user VALUES ('localhost','root','','Y','Y','Y','Y','Y',
'Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y',' Y','Y','Y','Y','','','','',0,0
,0);
# INSERT INTO mysql.user VALUES ('192.168.0.202','root','','Y','Y','Y','Y','Y',
#'Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y',' Y','Y','Y','Y','','','','',0,0
#,0);
 DROP TABLE IF EXISTS mysql.func;
 CREATE TABLE mysql.func (
 name char(64) binary DEFAULT '' NOT NULL,
 ret tinyint(1) DEFAULT '0' NOT NULL,
 dl char(128) DEFAULT '' NOT NULL,
 type enum ('function','aggregate') NOT NULL,
 PRIMARY KEY (name)
 )
  comment='User defined functions';

 DROP TABLE IF EXISTS mysql.tables_priv;
 CREATE TABLE mysql.tables_priv (
 Host char(60) binary DEFAULT '' NOT NULL,
 Db char(64) binary DEFAULT '' NOT NULL,
 User char(16) binary DEFAULT '' NOT NULL,
 Table_name char(60) binary DEFAULT '' NOT NULL,
 Grantor char(77) DEFAULT '' NOT NULL,
 Timestamp timestamp(14),
 Table_priv set('Select','Insert','Update','Delete','Create','Drop','Grant','References','Index','Alter') DEFAULT '' NOT NULL,
 Column_priv set('Select','Insert','Update','References') DEFAULT '' NOT NULL,
 PRIMARY KEY (Host,Db,User,Table_name),
 KEY Grantor (Grantor)
 )
 comment='Table privileges';

 DROP TABLE IF EXISTS mysql.columns_priv;
 CREATE TABLE mysql.columns_priv (
 Host char(60) binary DEFAULT '' NOT NULL,
 Db char(64) binary DEFAULT '' NOT NULL,
 User char(16) binary DEFAULT '' NOT NULL,
 Table_name char(64) binary DEFAULT '' NOT NULL,
 Column_name char(64) binary DEFAULT '' NOT NULL,
 Timestamp timestamp(14),
 Column_priv set('Select','Insert','Update','References') DEFAULT '' NOT NULL,
 PRIMARY KEY (Host,Db,User,Table_name,Column_name)
 )
 comment='Column privileges';

 DROP TABLE IF EXISTS mysql.help_topic;
 CREATE TABLE mysql.help_topic (
   help_topic_id    int unsigned not null,
   name             varchar(64) not null,
   help_category_id smallint unsigned not null,
   description      text not null,
   example          text not null,
   url              varchar(128) not null,
   primary key      (help_topic_id),
   unique index     (name)
 )
   comment='help topics';

 DROP TABLE IF EXISTS mysql.help_catefory;
 CREATE TABLE mysql.help_category (
   help_category_id   smallint unsigned not null,
   name               varchar(64) not null,
   parent_category_id smallint unsigned null,
   url                varchar(128) not null,
   primary key        (help_category_id),
   unique index       (name)
 )
   comment='help categories';

 DROP TABLE IF EXISTS mysql.help_keyword;
 CREATE TABLE mysql.help_keyword (
   help_keyword_id  int unsigned not null,
   name             varchar(64) not null,
   primary key      (help_keyword_id),
   unique index     (name)
 )
   comment='help keywords';

 DROP TABLE IF EXISTS mysql.help_relation;
 CREATE TABLE mysql.help_relation (
   help_topic_id    int unsigned not null references help_topic,
   help_keyword_id  int unsigned not null references help_keyword,
   primary key      (help_keyword_id, help_topic_id)
 )
   comment='keyword-topic relation';



 commit;
$exit
