#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <descrip.h>
#include <lib$routines.h>
#include <smg$routines.h>				/* SMG$name   */
#include <smgdef.h>					/* SMG$x_name */
#include <smgmsg.h>					/* SMG$_name  */
#include <ssdef.h>					/* SS$_NAME   */
#include <trmdef.h>
#include <stsdef.h>

#define S_PASSWORD 255  /* size of password buffer */

/* SMG$ support */
static long gl_keyboard_id;	/* SMG$ */
static long gl_key_table_id;	/* SMG$ */
static char LineBuffer[256];

char *
vms__readline(char *prompt)
{
	int n;
	struct dsc$descriptor_s	inputD;
	struct dsc$descriptor_s	promptD;
	struct dsc$descriptor_s* promptPtr;
	unsigned short int reslen;
	unsigned long l_flags;
	int s;	
	struct xr_rlbuffer* ar_rlbuffer;
	unsigned long l_linecount;
	unsigned long x_same_line;

	if (gl_key_table_id == 0) {
		s = smg$create_key_table(&gl_key_table_id);
		if (s != SS$_NORMAL) {
			perror("SMG$CREATE_KEY_TABLE() failed\n");
			exit(s);
		}
	}
	if (gl_keyboard_id == 0) {
		s = smg$create_virtual_keyboard(&gl_keyboard_id);
		if (s != SS$_NORMAL) {
			perror("SMG$CREATE_VIRTUAL_KEYBOARD() failed\n");
			exit(s);
    		}
	}

	fflush(stdout);

	/* set up descriptors */
	inputD.dsc$w_length  = sizeof(LineBuffer) - 2;
	inputD.dsc$b_dtype   = DSC$K_DTYPE_T;
	inputD.dsc$b_class   = DSC$K_CLASS_S; /* @@ use a Dyndesc ? */
	inputD.dsc$a_pointer = LineBuffer;

	if (prompt)
	{
	    promptD.dsc$w_length  = strlen(prompt);
	    promptD.dsc$b_dtype   = DSC$K_DTYPE_T;
	    promptD.dsc$b_class   = DSC$K_CLASS_S;
	    promptD.dsc$a_pointer = prompt;
	    promptPtr = &promptD;
	}
	else
	{
	    promptPtr = 0;			/* no prompt */
	}

	l_flags = 0; /* SMG$M_NOKEEP + SMG$M_NORECALL; */
	s = smg$read_composed_line
		(&gl_keyboard_id		/* keyboard-id            */
		,&gl_key_table_id		/* [key-table-id]         */
		,&inputD			/* resultant-string       */
		,promptPtr			/* [prompt-string]        */
		,&reslen	 		/* [resultant-length]     */
		,0				/* [display-id]           */
		,&l_flags			/* [flags]                */
		,0				/* [initial-string]       */
		,0				/* [timeout]              */
		,0				/* [rendition-set]        */
		,0				/* [rendition-complement] */
		,0				/* [word-terminator-code] */
		);

	if ((s != SS$_NORMAL) &&
	    (s != SS$_ABORT)  &&
	    (s != SS$_CANCEL) &&
	    (s != SMG$_EOF)
	   )
	{
	    return NULL;
	}

	if (s == SMG$_EOF) {
	    return NULL;
	}

	if ((s == SS$_ABORT)  || (s == SS$_CANCEL)) {
	    return NULL;
	} else {
	    LineBuffer[reslen] = '\0';
	}

	return LineBuffer;
}

char *
get_tty_password(char *prompt)
{
	int maxlen = sizeof(LineBuffer) - 1;
	unsigned int modifiers =  TRM$M_TM_NOECHO;
	$DESCRIPTOR(strD, LineBuffer);
	unsigned short reslen;
	struct dsc$descriptor_s	promptD;
	int s;

	if (gl_key_table_id == 0) {
		s = smg$create_key_table(&gl_key_table_id);
		if (s != SS$_NORMAL) {
			perror("SMG$CREATE_KEY_TABLE() failed\n");
			exit(s);
		}
	}
	if (gl_keyboard_id == 0) {
		s = smg$create_virtual_keyboard(&gl_keyboard_id);
		if (s != SS$_NORMAL) {
			perror("SMG$CREATE_VIRTUAL_KEYBOARD() failed\n");
			exit(s);
    		}
	}

	promptD.dsc$b_dtype   = DSC$K_DTYPE_T;
	promptD.dsc$b_class   = DSC$K_CLASS_S;
	if (prompt)
	{
	    promptD.dsc$a_pointer = prompt;
	}
	else
	{
	    promptD.dsc$a_pointer = "Enter password: ";	/* default prompt */
	}
	promptD.dsc$w_length  = strlen(promptD.dsc$a_pointer);

        s = smg$read_string(
                &gl_keyboard_id,
                &strD,
                &promptD,
                &maxlen,
                &modifiers,
                0,
                0,
                &reslen,
                0,
                0,
                0,
                0,
                0,
                0);

        if (!$VMS_STATUS_SUCCESS(s)) {
		exit(s);
	}
	LineBuffer[reslen] = '\0';
	return strdup(LineBuffer);
}
